Index: lemon/dim2.h
===================================================================
--- lemon/dim2.h	(revision 761)
+++ lemon/dim2.h	(revision 314)
@@ -3,5 +3,5 @@
  * This file is a part of LEMON, a generic C++ optimization library.
  *
- * Copyright (C) 2003-2009
+ * Copyright (C) 2003-2008
  * Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
  * (Egervary Research Group on Combinatorial Optimization, EGRES).
@@ -22,7 +22,14 @@
 #include <iostream>
 
-///\ingroup geomdat
+///\ingroup misc
 ///\file
 ///\brief A simple two dimensional vector and a bounding box implementation
+///
+/// The class \ref lemon::dim2::Point "dim2::Point" implements
+/// a two dimensional vector with the usual operations.
+///
+/// The class \ref lemon::dim2::Box "dim2::Box" can be used to determine
+/// the rectangular bounding box of a set of
+/// \ref lemon::dim2::Point "dim2::Point"'s.
 
 namespace lemon {
@@ -34,5 +41,5 @@
   namespace dim2 {
 
-  /// \addtogroup geomdat
+  /// \addtogroup misc
   /// @{
 
Index: lemon/error.h
===================================================================
--- lemon/error.h	(revision 463)
+++ lemon/error.h	(revision 291)
@@ -3,5 +3,5 @@
  * This file is a part of LEMON, a generic C++ optimization library.
  *
- * Copyright (C) 2003-2009
+ * Copyright (C) 2003-2008
  * Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
  * (Egervary Research Group on Combinatorial Optimization, EGRES).
Index: lemon/graph_to_eps.h
===================================================================
--- lemon/graph_to_eps.h	(revision 956)
+++ lemon/graph_to_eps.h	(revision 906)
@@ -3,5 +3,5 @@
  * This file is a part of LEMON, a generic C++ optimization library.
  *
- * Copyright (C) 2003-2010
+ * Copyright (C) 2003-2008
  * Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
  * (Egervary Research Group on Combinatorial Optimization, EGRES).
@@ -65,10 +65,9 @@
 ///Default traits class of \ref GraphToEps.
 ///
-///\param GR is the type of the underlying graph.
-template<class GR>
+///\c G is the type of the underlying graph.
+template<class G>
 struct DefaultGraphToEpsTraits
 {
-  typedef GR Graph;
-  typedef GR Digraph;
+  typedef G Graph;
   typedef typename Graph::Node Node;
   typedef typename Graph::NodeIt NodeIt;
@@ -141,12 +140,13 @@
 
   ///Constructor
-  ///\param gr  Reference to the graph to be printed.
-  ///\param ost Reference to the output stream.
-  ///By default, it is <tt>std::cout</tt>.
-  ///\param pros If it is \c true, then the \c ostream referenced by \c os
+  ///\param _g  Reference to the graph to be printed.
+  ///\param _os Reference to the output stream.
+  ///\param _os Reference to the output stream.
+  ///By default it is <tt>std::cout</tt>.
+  ///\param _pros If it is \c true, then the \c ostream referenced by \c _os
   ///will be explicitly deallocated by the destructor.
-  DefaultGraphToEpsTraits(const GR &gr, std::ostream& ost = std::cout,
-                          bool pros = false) :
-    g(gr), os(ost),
+  DefaultGraphToEpsTraits(const G &_g,std::ostream& _os=std::cout,
+                          bool _pros=false) :
+    g(_g), os(_os),
     _coords(dim2::Point<double>(1,1)), _nodeSizes(1), _nodeShapes(0),
     _nodeColors(WHITE), _arcColors(BLACK),
@@ -159,6 +159,6 @@
     _showNodeText(false), _nodeTexts(false), _nodeTextSize(1),
     _showNodePsText(false), _nodePsTexts(false), _nodePsTextsPreamble(0),
-    _undirected(lemon::UndirectedTagIndicator<GR>::value),
-    _pleaseRemoveOsStream(pros), _scaleToA4(false),
+    _undirected(lemon::UndirectedTagIndicator<G>::value),
+    _pleaseRemoveOsStream(_pros), _scaleToA4(false),
     _nodeTextColorType(SAME_COL), _nodeTextColors(BLACK),
     _autoNodeScale(false),
@@ -243,5 +243,4 @@
 
   typedef typename T::Graph Graph;
-  typedef typename T::Digraph Digraph;
   typedef typename Graph::Node Node;
   typedef typename Graph::NodeIt NodeIt;
@@ -271,16 +270,20 @@
     ///\image html nodeshape_1.png
     ///\image latex nodeshape_1.eps "SQUARE shape (1)" width=2cm
+    ///
     SQUARE=1,
     /// = 2
     ///\image html nodeshape_2.png
     ///\image latex nodeshape_2.eps "DIAMOND shape (2)" width=2cm
+    ///
     DIAMOND=2,
     /// = 3
     ///\image html nodeshape_3.png
-    ///\image latex nodeshape_3.eps "MALE shape (3)" width=2cm
+    ///\image latex nodeshape_2.eps "MALE shape (4)" width=2cm
+    ///
     MALE=3,
     /// = 4
     ///\image html nodeshape_4.png
-    ///\image latex nodeshape_4.eps "FEMALE shape (4)" width=2cm
+    ///\image latex nodeshape_2.eps "FEMALE shape (4)" width=2cm
+    ///
     FEMALE=4
   };
@@ -513,5 +516,5 @@
   ///Turn on/off pre-scaling
 
-  ///By default, graphToEps() rescales the whole image in order to avoid
+  ///By default graphToEps() rescales the whole image in order to avoid
   ///very big or very small bounding boxes.
   ///
@@ -1115,5 +1118,5 @@
 ///\param g Reference to the graph to be printed.
 ///\param os Reference to the output stream.
-///By default, it is <tt>std::cout</tt>.
+///By default it is <tt>std::cout</tt>.
 ///
 ///This function also has a lot of
@@ -1127,16 +1130,16 @@
 ///\endcode
 ///
-///For more detailed examples, see the \ref graph_to_eps_demo.cc demo file.
+///For more detailed examples see the \ref graph_to_eps_demo.cc demo file.
 ///
 ///\warning Don't forget to put the \ref GraphToEps::run() "run()"
 ///to the end of the parameter list.
 ///\sa GraphToEps
-///\sa graphToEps(GR &g, const char *file_name)
-template<class GR>
-GraphToEps<DefaultGraphToEpsTraits<GR> >
-graphToEps(GR &g, std::ostream& os=std::cout)
+///\sa graphToEps(G &g, const char *file_name)
+template<class G>
+GraphToEps<DefaultGraphToEpsTraits<G> >
+graphToEps(G &g, std::ostream& os=std::cout)
 {
   return
-    GraphToEps<DefaultGraphToEpsTraits<GR> >(DefaultGraphToEpsTraits<GR>(g,os));
+    GraphToEps<DefaultGraphToEpsTraits<G> >(DefaultGraphToEpsTraits<G>(g,os));
 }
 
@@ -1145,11 +1148,11 @@
 ///\ingroup eps_io
 ///This function does the same as
-///\ref graphToEps(GR &g,std::ostream& os)
+///\ref graphToEps(G &g,std::ostream& os)
 ///but it writes its output into the file \c file_name
 ///instead of a stream.
-///\sa graphToEps(GR &g, std::ostream& os)
-template<class GR>
-GraphToEps<DefaultGraphToEpsTraits<GR> >
-graphToEps(GR &g,const char *file_name)
+///\sa graphToEps(G &g, std::ostream& os)
+template<class G>
+GraphToEps<DefaultGraphToEpsTraits<G> >
+graphToEps(G &g,const char *file_name)
 {
   std::ostream* os = new std::ofstream(file_name);
@@ -1158,6 +1161,6 @@
     throw IoError("Cannot write file", file_name);
   }
-  return GraphToEps<DefaultGraphToEpsTraits<GR> >
-    (DefaultGraphToEpsTraits<GR>(g,*os,true));
+  return GraphToEps<DefaultGraphToEpsTraits<G> >
+    (DefaultGraphToEpsTraits<G>(g,*os,true));
 }
 
@@ -1166,11 +1169,11 @@
 ///\ingroup eps_io
 ///This function does the same as
-///\ref graphToEps(GR &g,std::ostream& os)
+///\ref graphToEps(G &g,std::ostream& os)
 ///but it writes its output into the file \c file_name
 ///instead of a stream.
-///\sa graphToEps(GR &g, std::ostream& os)
-template<class GR>
-GraphToEps<DefaultGraphToEpsTraits<GR> >
-graphToEps(GR &g,const std::string& file_name)
+///\sa graphToEps(G &g, std::ostream& os)
+template<class G>
+GraphToEps<DefaultGraphToEpsTraits<G> >
+graphToEps(G &g,const std::string& file_name)
 {
   std::ostream* os = new std::ofstream(file_name.c_str());
@@ -1179,6 +1182,6 @@
     throw IoError("Cannot write file", file_name);
   }
-  return GraphToEps<DefaultGraphToEpsTraits<GR> >
-    (DefaultGraphToEpsTraits<GR>(g,*os,true));
+  return GraphToEps<DefaultGraphToEpsTraits<G> >
+    (DefaultGraphToEpsTraits<G>(g,*os,true));
 }
 
Index: lemon/kruskal.h
===================================================================
--- lemon/kruskal.h	(revision 631)
+++ lemon/kruskal.h	(revision 220)
@@ -3,5 +3,5 @@
  * This file is a part of LEMON, a generic C++ optimization library.
  *
- * Copyright (C) 2003-2009
+ * Copyright (C) 2003-2008
  * Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
  * (Egervary Research Group on Combinatorial Optimization, EGRES).
@@ -249,9 +249,9 @@
   /// \ingroup spantree
   ///
-  /// \brief Kruskal's algorithm for finding a minimum cost spanning tree of
+  /// \brief Kruskal algorithm to find a minimum cost spanning tree of
   /// a graph.
   ///
   /// This function runs Kruskal's algorithm to find a minimum cost
-  /// spanning tree of a graph.
+  /// spanning tree.
   /// Due to some C++ hacking, it accepts various input and output types.
   ///
@@ -265,7 +265,7 @@
   /// It can be one of the following choices.
   /// - An STL compatible 'Forward Container' with
-  /// <tt>std::pair<GR::Arc,C></tt> or
-  /// <tt>std::pair<GR::Edge,C></tt> as its <tt>value_type</tt>, where
-  /// \c C is the type of the costs. The pairs indicates the arcs/edges
+  /// <tt>std::pair<GR::Arc,X></tt> or
+  /// <tt>std::pair<GR::Edge,X></tt> as its <tt>value_type</tt>, where
+  /// \c X is the type of the costs. The pairs indicates the arcs/edges
   /// along with the assigned cost. <em>They must be in a
   /// cost-ascending order.</em>
@@ -274,6 +274,6 @@
   ///
   /// \retval out Here we also have a choice.
-  /// - It can be a writable arc/edge map with \c bool value type. After
-  /// running the algorithm it will contain the found minimum cost spanning
+  /// - It can be a writable \c bool arc/edge map. After running the
+  /// algorithm it will contain the found minimum cost spanning
   /// tree: the value of an arc/edge will be set to \c true if it belongs
   /// to the tree, otherwise it will be set to \c false. The value of
@@ -302,6 +302,6 @@
 
 #ifdef DOXYGEN
-  template <typename Graph, typename In, typename Out>
-  Value kruskal(const Graph& g, const In& in, Out& out)
+  template <class Graph, class In, class Out>
+  Value kruskal(GR const& g, const In& in, Out& out)
 #else
   template <class Graph, class In, class Out>
@@ -315,4 +315,6 @@
 
 
+
+
   template <class Graph, class In, class Out>
   inline typename _kruskal_bits::KruskalValueSelector<In>::Value
Index: lemon/lemon.pc.in
===================================================================
--- lemon/lemon.pc.in	(revision 705)
+++ lemon/lemon.pc.in	(revision 259)
@@ -5,6 +5,6 @@
 
 Name: @PACKAGE_NAME@
-Description: Library for Efficient Modeling and Optimization in Networks
+Description: Library of Efficient Models and Optimization in Networks
 Version: @PACKAGE_VERSION@
-Libs: -L${libdir} -lemon @GLPK_LIBS@ @CPLEX_LIBS@ @SOPLEX_LIBS@ @CLP_LIBS@ @CBC_LIBS@
+Libs: -L${libdir} -lemon
 Cflags: -I${includedir}
Index: lemon/lgf_reader.h
===================================================================
--- lemon/lgf_reader.h	(revision 956)
+++ lemon/lgf_reader.h	(revision 517)
@@ -3,5 +3,5 @@
  * This file is a part of LEMON, a generic C++ optimization library.
  *
- * Copyright (C) 2003-2010
+ * Copyright (C) 2003-2008
  * Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
  * (Egervary Research Group on Combinatorial Optimization, EGRES).
@@ -102,21 +102,21 @@
     };
 
-    template <typename _GR, bool _dir, typename _Map,
+    template <typename _Graph, bool _dir, typename _Map,
               typename _Converter = DefaultConverter<typename _Map::Value> >
-    class GraphArcMapStorage : public MapStorageBase<typename _GR::Edge> {
+    class GraphArcMapStorage : public MapStorageBase<typename _Graph::Edge> {
     public:
       typedef _Map Map;
       typedef _Converter Converter;
-      typedef _GR GR;
-      typedef typename GR::Edge Item;
+      typedef _Graph Graph;
+      typedef typename Graph::Edge Item;
       static const bool dir = _dir;
 
     private:
-      const GR& _graph;
+      const Graph& _graph;
       Map& _map;
       Converter _converter;
 
     public:
-      GraphArcMapStorage(const GR& graph, Map& map,
+      GraphArcMapStorage(const Graph& graph, Map& map,
                          const Converter& converter = Converter())
         : _graph(graph), _map(map), _converter(converter) {}
@@ -174,19 +174,19 @@
     };
 
-    template <typename GR>
+    template <typename Graph>
     struct GraphArcLookUpConverter {
-      const GR& _graph;
-      const std::map<std::string, typename GR::Edge>& _map;
-
-      GraphArcLookUpConverter(const GR& graph,
+      const Graph& _graph;
+      const std::map<std::string, typename Graph::Edge>& _map;
+
+      GraphArcLookUpConverter(const Graph& graph,
                               const std::map<std::string,
-                                             typename GR::Edge>& map)
+                                             typename Graph::Edge>& map)
         : _graph(graph), _map(map) {}
 
-      typename GR::Arc operator()(const std::string& str) {
+      typename Graph::Arc operator()(const std::string& str) {
         if (str.empty() || (str[0] != '+' && str[0] != '-')) {
           throw FormatError("Item must start with '+' or '-'");
         }
-        typename std::map<std::string, typename GR::Edge>
+        typename std::map<std::string, typename Graph::Edge>
           ::const_iterator it = _map.find(str.substr(1));
         if (it == _map.end()) {
@@ -388,13 +388,14 @@
   }
 
-  template <typename DGR>
+  template <typename Digraph>
   class DigraphReader;
 
-  template <typename TDGR>
-  DigraphReader<TDGR> digraphReader(TDGR& digraph, std::istream& is = std::cin);
-  template <typename TDGR>
-  DigraphReader<TDGR> digraphReader(TDGR& digraph, const std::string& fn);
-  template <typename TDGR>
-  DigraphReader<TDGR> digraphReader(TDGR& digraph, const char *fn);
+  template <typename Digraph>
+  DigraphReader<Digraph> digraphReader(Digraph& digraph, 
+                                       std::istream& is = std::cin);
+  template <typename Digraph>
+  DigraphReader<Digraph> digraphReader(Digraph& digraph, const std::string& fn);
+  template <typename Digraph>
+  DigraphReader<Digraph> digraphReader(Digraph& digraph, const char *fn);
 
   /// \ingroup lemon_io
@@ -419,5 +420,5 @@
   ///
   ///\code
-  /// DigraphReader<DGR>(digraph, std::cin).
+  /// DigraphReader<Digraph>(digraph, std::cin).
   ///   nodeMap("coordinates", coord_map).
   ///   arcMap("capacity", cap_map).
@@ -428,5 +429,5 @@
   ///\endcode
   ///
-  /// By default, the reader uses the first section in the file of the
+  /// By default the reader uses the first section in the file of the
   /// proper type. If a section has an optional name, then it can be
   /// selected for reading by giving an optional name parameter to the
@@ -448,13 +449,13 @@
   /// a single pass, because the arcs are not constructed when the node
   /// maps are read.
-  template <typename DGR>
+  template <typename _Digraph>
   class DigraphReader {
   public:
 
-    typedef DGR Digraph;
+    typedef _Digraph Digraph;
+    TEMPLATE_DIGRAPH_TYPEDEFS(Digraph);
 
   private:
 
-    TEMPLATE_DIGRAPH_TYPEDEFS(DGR);
 
     std::istream* _is;
@@ -462,5 +463,5 @@
     std::string _filename;
 
-    DGR& _digraph;
+    Digraph& _digraph;
 
     std::string _nodes_caption;
@@ -500,5 +501,5 @@
     /// Construct a directed graph reader, which reads from the given
     /// input stream.
-    DigraphReader(DGR& digraph, std::istream& is = std::cin)
+    DigraphReader(Digraph& digraph, std::istream& is = std::cin)
       : _is(&is), local_is(false), _digraph(digraph),
         _use_nodes(false), _use_arcs(false),
@@ -509,5 +510,5 @@
     /// Construct a directed graph reader, which reads from the given
     /// file.
-    DigraphReader(DGR& digraph, const std::string& fn)
+    DigraphReader(Digraph& digraph, const std::string& fn)
       : _is(new std::ifstream(fn.c_str())), local_is(true),
         _filename(fn), _digraph(digraph),
@@ -524,5 +525,5 @@
     /// Construct a directed graph reader, which reads from the given
     /// file.
-    DigraphReader(DGR& digraph, const char* fn)
+    DigraphReader(Digraph& digraph, const char* fn)
       : _is(new std::ifstream(fn)), local_is(true),
         _filename(fn), _digraph(digraph),
@@ -560,11 +561,11 @@
   private:
 
-    template <typename TDGR>
-    friend DigraphReader<TDGR> digraphReader(TDGR& digraph, std::istream& is);
-    template <typename TDGR>
-    friend DigraphReader<TDGR> digraphReader(TDGR& digraph,
-                                             const std::string& fn);
-    template <typename TDGR>
-    friend DigraphReader<TDGR> digraphReader(TDGR& digraph, const char *fn);
+    template <typename DGR>
+    friend DigraphReader<DGR> digraphReader(DGR& digraph, std::istream& is);
+    template <typename DGR>
+    friend DigraphReader<DGR> digraphReader(DGR& digraph, 
+                                            const std::string& fn);
+    template <typename DGR>
+    friend DigraphReader<DGR> digraphReader(DGR& digraph, const char *fn);
 
     DigraphReader(DigraphReader& other)
@@ -593,5 +594,5 @@
   public:
 
-    /// \name Reading Rules
+    /// \name Reading rules
     /// @{
 
@@ -698,5 +699,5 @@
     /// @}
 
-    /// \name Select Section by Name
+    /// \name Select section by name
     /// @{
 
@@ -727,5 +728,5 @@
     /// @}
 
-    /// \name Using Previously Constructed Node or Arc Set
+    /// \name Using previously constructed node or arc set
     /// @{
 
@@ -847,7 +848,5 @@
         readLine();
       }
-      if (readSuccess()) {
-        line.putback(c);
-      }
+      line.putback(c);
     }
 
@@ -1116,5 +1115,5 @@
   public:
 
-    /// \name Execution of the Reader
+    /// \name Execution of the reader
     /// @{
 
@@ -1189,49 +1188,11 @@
   };
 
-  /// \ingroup lemon_io
-  ///
-  /// \brief Return a \ref DigraphReader class
-  ///
-  /// This function just returns a \ref DigraphReader class.
-  ///
-  /// With this function a digraph can be read from an
-  /// \ref lgf-format "LGF" file or input stream with several maps and
-  /// attributes. For example, there is network flow problem on a
-  /// digraph, i.e. a digraph with a \e capacity map on the arcs and
-  /// \e source and \e target nodes. This digraph can be read with the
-  /// following code:
-  ///
-  ///\code
-  ///ListDigraph digraph;
-  ///ListDigraph::ArcMap<int> cm(digraph);
-  ///ListDigraph::Node src, trg;
-  ///digraphReader(digraph, std::cin).
-  ///  arcMap("capacity", cap).
-  ///  node("source", src).
-  ///  node("target", trg).
-  ///  run();
-  ///\endcode
-  ///
-  /// For a complete documentation, please see the \ref DigraphReader
-  /// class documentation.
-  /// \warning Don't forget to put the \ref DigraphReader::run() "run()"
-  /// to the end of the parameter list.
-  /// \relates DigraphReader
-  /// \sa digraphReader(TDGR& digraph, const std::string& fn)
-  /// \sa digraphReader(TDGR& digraph, const char* fn)
-  template <typename TDGR>
-  DigraphReader<TDGR> digraphReader(TDGR& digraph, std::istream& is) {
-    DigraphReader<TDGR> tmp(digraph, is);
-    return tmp;
-  }
-
   /// \brief Return a \ref DigraphReader class
   ///
   /// This function just returns a \ref DigraphReader class.
   /// \relates DigraphReader
-  /// \sa digraphReader(TDGR& digraph, std::istream& is)
-  template <typename TDGR>
-  DigraphReader<TDGR> digraphReader(TDGR& digraph, const std::string& fn) {
-    DigraphReader<TDGR> tmp(digraph, fn);
+  template <typename Digraph>
+  DigraphReader<Digraph> digraphReader(Digraph& digraph, std::istream& is) {
+    DigraphReader<Digraph> tmp(digraph, is);
     return tmp;
   }
@@ -1241,20 +1202,31 @@
   /// This function just returns a \ref DigraphReader class.
   /// \relates DigraphReader
-  /// \sa digraphReader(TDGR& digraph, std::istream& is)
-  template <typename TDGR>
-  DigraphReader<TDGR> digraphReader(TDGR& digraph, const char* fn) {
-    DigraphReader<TDGR> tmp(digraph, fn);
+  template <typename Digraph>
+  DigraphReader<Digraph> digraphReader(Digraph& digraph,
+                                       const std::string& fn) {
+    DigraphReader<Digraph> tmp(digraph, fn);
     return tmp;
   }
 
-  template <typename GR>
+  /// \brief Return a \ref DigraphReader class
+  ///
+  /// This function just returns a \ref DigraphReader class.
+  /// \relates DigraphReader
+  template <typename Digraph>
+  DigraphReader<Digraph> digraphReader(Digraph& digraph, const char* fn) {
+    DigraphReader<Digraph> tmp(digraph, fn);
+    return tmp;
+  }
+
+  template <typename Graph>
   class GraphReader;
-
-  template <typename TGR>
-  GraphReader<TGR> graphReader(TGR& graph, std::istream& is = std::cin);
-  template <typename TGR>
-  GraphReader<TGR> graphReader(TGR& graph, const std::string& fn);
-  template <typename TGR>
-  GraphReader<TGR> graphReader(TGR& graph, const char *fn);
+ 
+  template <typename Graph>
+  GraphReader<Graph> graphReader(Graph& graph, 
+                                 std::istream& is = std::cin);
+  template <typename Graph>
+  GraphReader<Graph> graphReader(Graph& graph, const std::string& fn);
+  template <typename Graph>
+  GraphReader<Graph> graphReader(Graph& graph, const char *fn);
 
   /// \ingroup lemon_io
@@ -1273,13 +1245,12 @@
   /// arc map.  Similarly, an attribute can be read into an arc, if
   /// it's value is an edge label prefixed with \c '+' or \c '-'.
-  template <typename GR>
+  template <typename _Graph>
   class GraphReader {
   public:
 
-    typedef GR Graph;
+    typedef _Graph Graph;
+    TEMPLATE_GRAPH_TYPEDEFS(Graph);
 
   private:
-
-    TEMPLATE_GRAPH_TYPEDEFS(GR);
 
     std::istream* _is;
@@ -1287,5 +1258,5 @@
     std::string _filename;
 
-    GR& _graph;
+    Graph& _graph;
 
     std::string _nodes_caption;
@@ -1325,5 +1296,5 @@
     /// Construct an undirected graph reader, which reads from the given
     /// input stream.
-    GraphReader(GR& graph, std::istream& is = std::cin)
+    GraphReader(Graph& graph, std::istream& is = std::cin)
       : _is(&is), local_is(false), _graph(graph),
         _use_nodes(false), _use_edges(false),
@@ -1334,5 +1305,5 @@
     /// Construct an undirected graph reader, which reads from the given
     /// file.
-    GraphReader(GR& graph, const std::string& fn)
+    GraphReader(Graph& graph, const std::string& fn)
       : _is(new std::ifstream(fn.c_str())), local_is(true),
         _filename(fn), _graph(graph),
@@ -1349,5 +1320,5 @@
     /// Construct an undirected graph reader, which reads from the given
     /// file.
-    GraphReader(GR& graph, const char* fn)
+    GraphReader(Graph& graph, const char* fn)
       : _is(new std::ifstream(fn)), local_is(true),
         _filename(fn), _graph(graph),
@@ -1384,10 +1355,10 @@
 
   private:
-    template <typename TGR>
-    friend GraphReader<TGR> graphReader(TGR& graph, std::istream& is);
-    template <typename TGR>
-    friend GraphReader<TGR> graphReader(TGR& graph, const std::string& fn);
-    template <typename TGR>
-    friend GraphReader<TGR> graphReader(TGR& graph, const char *fn);
+    template <typename GR>
+    friend GraphReader<GR> graphReader(GR& graph, std::istream& is);
+    template <typename GR>
+    friend GraphReader<GR> graphReader(GR& graph, const std::string& fn); 
+    template <typename GR>
+    friend GraphReader<GR> graphReader(GR& graph, const char *fn);
 
     GraphReader(GraphReader& other)
@@ -1416,5 +1387,5 @@
   public:
 
-    /// \name Reading Rules
+    /// \name Reading rules
     /// @{
 
@@ -1481,5 +1452,5 @@
       _edge_maps.push_back(std::make_pair('+' + caption, forward_storage));
       _reader_bits::MapStorageBase<Edge>* backward_storage =
-        new _reader_bits::GraphArcMapStorage<GR, false, Map>(_graph, map);
+        new _reader_bits::GraphArcMapStorage<Graph, false, Map>(_graph, map);
       _edge_maps.push_back(std::make_pair('-' + caption, backward_storage));
       return *this;
@@ -1495,9 +1466,9 @@
       checkConcept<concepts::WriteMap<Arc, typename Map::Value>, Map>();
       _reader_bits::MapStorageBase<Edge>* forward_storage =
-        new _reader_bits::GraphArcMapStorage<GR, true, Map, Converter>
+        new _reader_bits::GraphArcMapStorage<Graph, true, Map, Converter>
         (_graph, map, converter);
       _edge_maps.push_back(std::make_pair('+' + caption, forward_storage));
       _reader_bits::MapStorageBase<Edge>* backward_storage =
-        new _reader_bits::GraphArcMapStorage<GR, false, Map, Converter>
+        new _reader_bits::GraphArcMapStorage<Graph, false, Map, Converter>
         (_graph, map, converter);
       _edge_maps.push_back(std::make_pair('-' + caption, backward_storage));
@@ -1557,5 +1528,5 @@
     /// Add an arc reading rule to reader.
     GraphReader& arc(const std::string& caption, Arc& arc) {
-      typedef _reader_bits::GraphArcLookUpConverter<GR> Converter;
+      typedef _reader_bits::GraphArcLookUpConverter<Graph> Converter;
       Converter converter(_graph, _edge_index);
       _reader_bits::ValueStorageBase* storage =
@@ -1567,5 +1538,5 @@
     /// @}
 
-    /// \name Select Section by Name
+    /// \name Select section by name
     /// @{
 
@@ -1596,5 +1567,5 @@
     /// @}
 
-    /// \name Using Previously Constructed Node or Edge Set
+    /// \name Using previously constructed node or edge set
     /// @{
 
@@ -1717,7 +1688,5 @@
         readLine();
       }
-      if (readSuccess()) {
-        line.putback(c);
-      }
+      line.putback(c);
     }
 
@@ -1986,5 +1955,5 @@
   public:
 
-    /// \name Execution of the Reader
+    /// \name Execution of the reader
     /// @{
 
@@ -2060,45 +2029,11 @@
   };
 
-  /// \ingroup lemon_io
-  ///
-  /// \brief Return a \ref GraphReader class
-  ///
-  /// This function just returns a \ref GraphReader class.
-  ///
-  /// With this function a graph can be read from an
-  /// \ref lgf-format "LGF" file or input stream with several maps and
-  /// attributes. For example, there is weighted matching problem on a
-  /// graph, i.e. a graph with a \e weight map on the edges. This
-  /// graph can be read with the following code:
-  ///
-  ///\code
-  ///ListGraph graph;
-  ///ListGraph::EdgeMap<int> weight(graph);
-  ///graphReader(graph, std::cin).
-  ///  edgeMap("weight", weight).
-  ///  run();
-  ///\endcode
-  ///
-  /// For a complete documentation, please see the \ref GraphReader
-  /// class documentation.
-  /// \warning Don't forget to put the \ref GraphReader::run() "run()"
-  /// to the end of the parameter list.
-  /// \relates GraphReader
-  /// \sa graphReader(TGR& graph, const std::string& fn)
-  /// \sa graphReader(TGR& graph, const char* fn)
-  template <typename TGR>
-  GraphReader<TGR> graphReader(TGR& graph, std::istream& is) {
-    GraphReader<TGR> tmp(graph, is);
-    return tmp;
-  }
-
   /// \brief Return a \ref GraphReader class
   ///
   /// This function just returns a \ref GraphReader class.
   /// \relates GraphReader
-  /// \sa graphReader(TGR& graph, std::istream& is)
-  template <typename TGR>
-  GraphReader<TGR> graphReader(TGR& graph, const std::string& fn) {
-    GraphReader<TGR> tmp(graph, fn);
+  template <typename Graph>
+  GraphReader<Graph> graphReader(Graph& graph, std::istream& is) {
+    GraphReader<Graph> tmp(graph, is);
     return tmp;
   }
@@ -2108,8 +2043,17 @@
   /// This function just returns a \ref GraphReader class.
   /// \relates GraphReader
-  /// \sa graphReader(TGR& graph, std::istream& is)
-  template <typename TGR>
-  GraphReader<TGR> graphReader(TGR& graph, const char* fn) {
-    GraphReader<TGR> tmp(graph, fn);
+  template <typename Graph>
+  GraphReader<Graph> graphReader(Graph& graph, const std::string& fn) {
+    GraphReader<Graph> tmp(graph, fn);
+    return tmp;
+  }
+
+  /// \brief Return a \ref GraphReader class
+  ///
+  /// This function just returns a \ref GraphReader class.
+  /// \relates GraphReader
+  template <typename Graph>
+  GraphReader<Graph> graphReader(Graph& graph, const char* fn) {
+    GraphReader<Graph> tmp(graph, fn);
     return tmp;
   }
@@ -2210,5 +2154,5 @@
   public:
 
-    /// \name Section Readers
+    /// \name Section readers
     /// @{
 
@@ -2222,5 +2166,5 @@
     /// whitespaces are trimmed from each processed string.
     ///
-    /// For example, let's see a section, which contain several
+    /// For example let's see a section, which contain several
     /// integers, which should be inserted into a vector.
     ///\code
@@ -2301,7 +2245,5 @@
         readLine();
       }
-      if (readSuccess()) {
-        line.putback(c);
-      }
+      line.putback(c);
     }
 
@@ -2309,5 +2251,5 @@
 
 
-    /// \name Execution of the Reader
+    /// \name Execution of the reader
     /// @{
 
@@ -2368,16 +2310,8 @@
   };
 
-  /// \ingroup lemon_io
-  ///
   /// \brief Return a \ref SectionReader class
   ///
   /// This function just returns a \ref SectionReader class.
-  ///
-  /// Please see SectionReader documentation about the custom section
-  /// input.
-  ///
   /// \relates SectionReader
-  /// \sa sectionReader(const std::string& fn)
-  /// \sa sectionReader(const char *fn)
   inline SectionReader sectionReader(std::istream& is) {
     SectionReader tmp(is);
@@ -2389,5 +2323,4 @@
   /// This function just returns a \ref SectionReader class.
   /// \relates SectionReader
-  /// \sa sectionReader(std::istream& is)
   inline SectionReader sectionReader(const std::string& fn) {
     SectionReader tmp(fn);
@@ -2399,5 +2332,4 @@
   /// This function just returns a \ref SectionReader class.
   /// \relates SectionReader
-  /// \sa sectionReader(std::istream& is)
   inline SectionReader sectionReader(const char* fn) {
     SectionReader tmp(fn);
@@ -2501,5 +2433,5 @@
 
 
-    /// \name Node Sections
+    /// \name Node sections
     /// @{
 
@@ -2527,5 +2459,5 @@
     /// @}
 
-    /// \name Arc/Edge Sections
+    /// \name Arc/Edge sections
     /// @{
 
@@ -2585,5 +2517,5 @@
     /// @}
 
-    /// \name Attribute Sections
+    /// \name Attribute sections
     /// @{
 
@@ -2611,5 +2543,5 @@
     /// @}
 
-    /// \name Extra Sections
+    /// \name Extra sections
     /// @{
 
@@ -2654,7 +2586,5 @@
         readLine();
       }
-      if (readSuccess()) {
-        line.putback(c);
-      }
+      line.putback(c);
     }
 
@@ -2687,5 +2617,5 @@
   public:
 
-    /// \name Execution of the Contents Reader
+    /// \name Execution of the contents reader
     /// @{
 
